<template>
  <div class="relative overflow-hidden rounded-md border border-gray-900/10 bg-white">
    <transition :duration="100">
      <template v-if="isLoading">
        <ProgressBar class="absolute rounded-t-md" />
      </template>
    </transition>
    <div class="px-5 py-4">
      <div class="flex items-center">
        <div class="flex-shrink-0 rounded-md bg-primary-500 p-3">
          <component
            :is="icon"
            aria-hidden="true"
            class="h-6 w-6 fill-white"
          />
        </div>
        <div class="ml-5 w-0 flex-1">
          <div>
            <div class="truncate text-sm font-medium text-gray-500">
              {{ $t(label) }}
            </div>
            <div class="flex items-baseline">
              <div class="text-2xl font-semibold text-gray-900">
                {{ value }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import type { FunctionalComponent, SVGAttributes } from "vue";
import ProgressBar from "@/js/contexts/shared/ui/components/loading/ProgressBar.vue";

defineProps<{
  value: number;
  label: string;
  isLoading: boolean;
  icon: FunctionalComponent<SVGAttributes>;
}>();
</script>
